﻿using System;
using System.Text;

namespace PropertyEditorCS
{
    class Native2Acscii
    {
        private static readonly Encoding ENCODING_SJIS = Encoding.GetEncoding("Shift_JIS");
        
        public static string Unescape(string source)
        {
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < source.Length; i++)
            {
                string s = source.Substring(i, 1);
                if (i < source.Length - 5 && source.Substring(i, 2) == "\\u")
                {
                    byte[] b = {Convert.ToByte(source.Substring(i + 2, 2), 16), 
                        Convert.ToByte(source.Substring(i + 4, 2), 16)};
                    s = Encoding.BigEndianUnicode.GetString(b);
                    i += 5;
                }
                sb.Append(s);
            }

            return sb.ToString();
        }

        public static string Escape(string source)
        {
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < source.Length; i++)
            {
                string c = source.Substring(i, 1);
                byte[] b = Encoding.BigEndianUnicode.GetBytes(c);
                if (IsZenkaku(c) || (b[0] == 0xfe && b[1] == 0xff))
                {
                    c = string.Format("\\u{0:X2}{1:X2}", b[0], b[1]).ToLower();
                }
                sb.Append(c);
            }

            return sb.ToString();
        }

        private static bool IsZenkaku(string s)
        {
            return ENCODING_SJIS.GetByteCount(s) == s.Length * 2;
        }
    }
}
